﻿using ScintillaNET;
using System;
using System.Globalization;
using System.IO;
using System.Windows.Forms;

namespace WindowsFormsApp
{
    public partial class Form1 : Form
    {
        string Key = "<License>\r\n  <ExpirationDate>9999-12-31T23:59:59.9999999</ExpirationDate>\r\n  <ID>TRIAL</ID>\r\n  <Modules>\r\n    <string>5AXIS</string>\r\n  </Modules>\r\n  <Signature>FaK0svHlTpY6j5HpvEh+7n3JANw8tDGaSOvLzI/P547nWwHYpTF8R+dGYOjMt/T/yJZ1XuY/z9JeAx6DSF9UF6A7BykSEosBlvF9CehXrZG/n0g/ndVI6lQZsrbXo3hH1q7yeOtR5ZEY72FS1q+RrdDUKrMLKlbwvU2+uCihzY8=</Signature>\r\n</License>";

        double x = 0.0;
        double y = 0.0;
        double z = 0.0;
        double rot1 = 0.0;
        double rot2 = 0.0;
        int tool = -1;

        public Form1()
        {
            InitializeComponent();
            ncView1.Start(Key);
            tech.SelectedIndex = 0;
        }

        private void import_Click(object sender, EventArgs e)
        {
            OpenFileDialog dialog = new OpenFileDialog();
            if (dialog.ShowDialog() == DialogResult.OK)
            {
                progressBar.Style = ProgressBarStyle.Marquee;
                foreach (Control ctrl in this.Controls) { ctrl.Enabled = false; }
                scintilla1.Text = string.Join("\r\n", File.ReadLines(dialog.FileName));
                ncView1.LoadFile(scintilla1.Text);
            }
        }

        private void ncView1_FileLoaded(object sender, EventArgs e)
        {
            progressBar.Style = ProgressBarStyle.Continuous;
            foreach (Control ctrl in Controls) { ctrl.Enabled = true; }
            trackBar1.Maximum = ncView1.JobMaxId;
        }

        private void reprocess_Click(object sender, EventArgs e)
        {
            progressBar.Style = ProgressBarStyle.Marquee;
            foreach (Control ctrl in Controls) { ctrl.Enabled = false; }
            ncView1.LoadFile(scintilla1.Text);
        }

        private void addStl_Click(object sender, EventArgs e)
        {
            OpenFileDialog dialog = new OpenFileDialog();
            dialog.Filter = "stl|*.stl";
            if (dialog.ShowDialog() == DialogResult.OK)
            {
                ncView1.LoadPart(dialog.FileName);
            }
        }

        private void clearStl_Click(object sender, EventArgs e)
        {
            ncView1.ClearParts();
        }

        private void ncView1_SelectionChanged(object source, NCneticLib.ncView.SelectionChangedEventArgs e)
        {
            BeginInvoke((MethodInvoker)delegate ()
            {
                x = (double)ncView1.GetValue(NCneticLib.ncView.ValueType.TARGET_X);
                y = (double)ncView1.GetValue(NCneticLib.ncView.ValueType.TARGET_Y);
                z = (double)ncView1.GetValue(NCneticLib.ncView.ValueType.TARGET_Z);
                rot1 = (double)ncView1.GetValue(NCneticLib.ncView.ValueType.TARGET_ROT1);
                rot2 = (double)ncView1.GetValue(NCneticLib.ncView.ValueType.TARGET_ROT2);
                tool = (int)ncView1.GetValue(NCneticLib.ncView.ValueType.TOOL_NUMBER);

                xLabel.Text = "X=" + x.ToString("0.000", CultureInfo.InvariantCulture);
                yLabel.Text = "Y=" + y.ToString("0.000", CultureInfo.InvariantCulture);
                zLabel.Text = "Z=" + z.ToString("0.000", CultureInfo.InvariantCulture);
                rot1Label.Text = "ROT1=" + rot1.ToString("0.000", CultureInfo.InvariantCulture);
                rot2Label.Text = "ROT2=" + rot2.ToString("0.000", CultureInfo.InvariantCulture);

                if (e.Id >= 0 && e.Id != trackBar1.Value)
                {
                    trackBar1.Value = e.Id;
                }
                if (e.Line >= 0 && e.Line != scintilla1.CurrentLine)
                {
                    scintilla1.Lines[e.Line].Goto();
                }
            });
        }

        private void scintilla1_UpdateUI(object sender, UpdateUIEventArgs e)
        {
            ncView1.GotoLine(scintilla1.CurrentLine);
        }

        private void trackBar1_ValueChanged(object sender, EventArgs e)
        {
            ncView1.GotoId(trackBar1.Value);
        }

        private void play_Click(object sender, EventArgs e)
        {
            ncView1.PauseSimulation();
            double speed = trackBar2.Value / 100;
            ncView1.PlaySimulation(speed);
        }

        private void tech_SelectedIndexChanged(object sender, EventArgs e)
        {
            ncView1.LoadFile(string.Empty);
            ncView1.ClearParts();

            ncView1.LoadToolDB("TOOL_DB.xml");

            switch (tech.SelectedIndex)
            {
                case 0:
                    ncView1.LoadMachine("3A.xml");
                    ncView1.LoadPart("3A.stl");
                    scintilla1.Text = string.Join("\r\n", File.ReadLines("3A.nc"));
                    break;
                case 1:
                    ncView1.LoadMachine("4A_A.xml");
                    ncView1.LoadPart("4A_A.stl");
                    scintilla1.Text = string.Join("\r\n", File.ReadLines("4A_A.nc"));
                    break;
                case 2:
                    ncView1.LoadMachine("4A_B.xml");
                    ncView1.LoadPart("4A_B.stl");
                    scintilla1.Text = string.Join("\r\n", File.ReadLines("4A_B.nc"));
                    break;
                case 3:
                    ncView1.LoadMachine("4AH_A.xml");
                    ncView1.LoadPart("4AH_A.stl");
                    scintilla1.Text = string.Join("\r\n", File.ReadLines("4AH_A.nc"));
                    break;
                case 4:
                    ncView1.LoadMachine("4AH_B.xml");
                    ncView1.LoadPart("4AH_B.stl");
                    scintilla1.Text = string.Join("\r\n", File.ReadLines("4AH_B.nc"));
                    break;
                case 5:
                    ncView1.LoadMachine("5A_AC.xml");
                    ncView1.LoadPart("5A.stl");
                    scintilla1.Text = string.Join("\r\n", File.ReadLines("5A_AC.nc"));
                    break;
                case 6:
                    ncView1.LoadMachine("5A_BC.xml");
                    ncView1.LoadPart("5A.stl");
                    scintilla1.Text = string.Join("\r\n", File.ReadLines("5A_BC.nc"));
                    break;
                case 7:
                    ncView1.LoadMachine("5AH_AB.xml");
                    ncView1.LoadPart("5A.stl");
                    scintilla1.Text = string.Join("\r\n", File.ReadLines("5AH_AB.nc"));
                    break;
                case 8:
                    ncView1.LoadMachine("5AH_BA.xml");
                    ncView1.LoadPart("5A.stl");
                    scintilla1.Text = string.Join("\r\n", File.ReadLines("5AH_BA.nc"));
                    break;
                case 9:
                    ncView1.LoadMachine("5AH_AC.xml");
                    ncView1.LoadPart("5A.stl");
                    scintilla1.Text = string.Join("\r\n", File.ReadLines("5AH_AC.nc"));
                    break;
                case 10:
                    ncView1.LoadMachine("5AH_BC.xml");
                    ncView1.LoadPart("5A.stl");
                    scintilla1.Text = string.Join("\r\n", File.ReadLines("5AH_BC.nc"));
                    break;
                case 11:
                    ncView1.LoadMachine("5AHH_AB.xml");
                    ncView1.LoadPart("5A.stl");
                    scintilla1.Text = string.Join("\r\n", File.ReadLines("5AHH_AB.nc"));
                    break;
                case 12:
                    ncView1.LoadMachine("5AHH_BA.xml");
                    ncView1.LoadPart("5A.stl");
                    scintilla1.Text = string.Join("\r\n", File.ReadLines("5AHH_BA.nc"));
                    break;
                case 13:
                    ncView1.LoadMachine("5AHH_AC.xml");
                    ncView1.LoadPart("5A.stl");
                    scintilla1.Text = string.Join("\r\n", File.ReadLines("5AHH_AC.nc"));
                    break;
                case 14:
                    ncView1.LoadMachine("5AHH_BC.xml");
                    ncView1.LoadPart("5A.stl");
                    scintilla1.Text = string.Join("\r\n", File.ReadLines("5AHH_BC.nc"));
                    break;
            }

            ncView1.LoadFile(scintilla1.Text);
        }

        private void xm_Click(object sender, EventArgs e)
        {
            x -= 10;
            ncView1.SetPosition(x, y, z, rot1, rot2, tool);
        }

        private void xp_Click(object sender, EventArgs e)
        {
            x += 10;
            ncView1.SetPosition(x, y, z, rot1, rot2, tool);
        }

        private void ym_Click(object sender, EventArgs e)
        {
            y -= 10;
            ncView1.SetPosition(x, y, z, rot1, rot2, tool);
        }

        private void yp_Click(object sender, EventArgs e)
        {
            y += 10;
            ncView1.SetPosition(x, y, z, rot1, rot2, tool);
        }

        private void zm_Click(object sender, EventArgs e)
        {
            z -= 10;
            ncView1.SetPosition(x, y, z, rot1, rot2, tool);
        }

        private void zp_Click(object sender, EventArgs e)
        {
            z += 10;
            ncView1.SetPosition(x, y, z, rot1, rot2, tool);
        }

        private void r1m_Click(object sender, EventArgs e)
        {
            rot1 -= 0.1;
            ncView1.SetPosition(x, y, z, rot1, rot2, tool);
        }

        private void r1p_Click(object sender, EventArgs e)
        {
            rot1 += 0.1;
            ncView1.SetPosition(x, y, z, rot1, rot2, tool);
        }

        private void r2m_Click(object sender, EventArgs e)
        {
            rot2 -= 0.1;
            ncView1.SetPosition(x, y, z, rot1, rot2, tool);
        }

        private void r2p_Click(object sender, EventArgs e)
        {
            rot2 += 0.1;
            ncView1.SetPosition(x, y, z, rot1, rot2, tool);
        }
    }
}
